////////////////////////////////////////////////////////////////////////////////
// 東方式神MOD

package mods.touhou_shikigami;

import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.Mod.EventHandler;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.registry.EntityRegistry;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.FMLLog;

import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.block.Block;
import net.minecraft.item.ItemStack;
import net.minecraftforge.common.config.Configuration;

/**
 * 東方式神MODクラス
 */
@Mod(
    modid = TouhouShikigami.MODID,
    name = TouhouShikigami.MODNAME,
    version = TouhouShikigami.VERSION
    )
public class TouhouShikigami
{
	/** MODの識別子 */
    public static final String MODID = "touhou_shikigami";
    /** MODの名前 */
    public static final String MODNAME = "Yukari's Shikigami MOD";
    /** MODのバージョン */
    public static final String VERSION = "1.7.2-i";

    /**
     * MODの唯一のインスタンス
     */
    @Instance("touhou_shikigami")
    public static TouhouShikigami instance;

    /**
     * サーバー・クライアントでの処理振り分け用プロキシ
     */
    @SidedProxy(
        clientSide = "mods.touhou_shikigami.client.ClientProxy",
        serverSide = "mods.touhou_shikigami.CommonProxy"
        )
    public static CommonProxy proxy;

    /**
     * 初期化前処理
     */
    @EventHandler
    public void preInit(FMLPreInitializationEvent event)
    {
        // コンフィグ読み込み
        Configuration cfg = new Configuration(
            event.getSuggestedConfigurationFile());
        try
        {
            cfg.load();

        }
        catch (Exception e)
        {
            FMLLog.severe("%s Configuration load error!");
        }
        finally
        {
            cfg.save();
        }

        // アイテムの登録
        registerItems();
    }

    /**
     * 初期化処理
     */
    @EventHandler
    public void init(FMLInitializationEvent event)
    {
        // エンティティの登録
        registerEntities();

        // レンダラの登録
        proxy.registerRenderers();

        // レシピの登録
        registerRecipes();
    }

    ////////////////////////////////////////////////////////////////////////////

    /**
     * アイテムの登録
     */
    private void registerItems()
    {
        itemShikigami = new ItemShikigami();
        
        GameRegistry.registerItem(itemShikigami, "shikigami");
    }
    
    /**
     * エンティティの登録
     */
    private void registerEntities()
    {
        
    }

    /**
     * レシピの登録
     */
    private void registerRecipes()
    {

    }

    ////////////////////////////////////////////////////////////////////////////

    public static Item itemShikigami;
}
